#ifndef _KGR_PATCH_BSC1047518_H
#define _KGR_PATCH_BSC1047518_H

#include <linux/types.h>

int kgr_patch_bsc1047518_init(void);
void kgr_patch_bsc1047518_cleanup(void);

struct btrfs_fs_info;
struct btrfs_trans_handle;
struct btrfs_delayed_extent_op;

int kgr_btrfs_add_delayed_tree_ref(struct btrfs_fs_info *fs_info,
				   struct btrfs_trans_handle *trans,
				   u64 bytenr, u64 num_bytes, u64 parent,
				   u64 ref_root,  int level, int action,
				   struct btrfs_delayed_extent_op *extent_op);

int kgr_btrfs_add_delayed_data_ref(struct btrfs_fs_info *fs_info,
				   struct btrfs_trans_handle *trans,
				   u64 bytenr, u64 num_bytes,
				   u64 parent, u64 ref_root,
				   u64 owner, u64 offset, u64 reserved, int action,
				   struct btrfs_delayed_extent_op *extent_op);

int kgr_btrfs_qgroup_trace_extent(struct btrfs_trans_handle *trans,
		struct btrfs_fs_info *fs_info, u64 bytenr, u64 num_bytes,
		gfp_t gfp_flag);

int kgr_btrfs_qgroup_prepare_account_extents(struct btrfs_trans_handle *trans,
					     struct btrfs_fs_info *fs_info);


#define KGR_PATCH_BSC1047518_FUNCS					\
	KGR_PATCH_OBJ(btrfs_add_delayed_tree_ref,			\
		kgr_btrfs_add_delayed_tree_ref, "btrfs"),		\
	KGR_PATCH_OBJ(btrfs_add_delayed_data_ref,			\
		kgr_btrfs_add_delayed_data_ref, "btrfs"),		\
	KGR_PATCH_OBJ(btrfs_qgroup_trace_extent,			\
		kgr_btrfs_qgroup_trace_extent, "btrfs"),		\
	KGR_PATCH_OBJ(btrfs_qgroup_prepare_account_extents,		\
		kgr_btrfs_qgroup_prepare_account_extents, "btrfs"),

#endif
